<?php

namespace App\Models;

use App\Models\Scopes\CompanyScope;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Requirement extends Model
{
    use HasFactory;

    protected $fillable = [
        'title',
        'asset_id',
        'status',
        'requirement_group_id',
        'priority',
        'note',
        'description',
        'acceptance',
        'mailto',
        'company_id',
    ];

    protected $casts = [
        'mailto' => 'array',
    ];

    protected static function booted()
    {
        parent::booted(); // TODO: Change the autogenerated stub

        static::addGlobalScope(new CompanyScope);
    }

    public function createdBy(): \Illuminate\Database\Eloquent\Relations\BelongsTo
    {
        return $this->belongsTo(User::class, 'created_by');
    }

    public function plan(): \Illuminate\Database\Eloquent\Relations\BelongsTo
    {
        return $this->belongsTo(Plan::class);
    }
}
